/*************************************************************/
/*  cube.c   SS Oct  94                                      */
/*                                                           */
/*************************************************************/

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <graphics.h>

double pi=3.14159265358979323;


void main()
{

   int gdriver = DETECT ,gmode;

   double xx[10];
   double yy[10];
   double zz[10];

   int xs[10][2];
   int ys[10][2];
   int xr[10];
   int yr[10];


   double vh,vv,sh,ch,sv,cv,w1,w2,w3,r,f,x,y,z;
   double xs0,ys0,x1,y1,z1,ww1,ww2,ww3,cy,cx,x2,y2,z2;
   double x0,y0,z0,dx,dy,dz,ssx1,ssx2,ssy1,ssy2,ssz1,ssz2,ss,cc;
   double xr2,yr2,zr2,rrr,ff;

   long i,j,flag,q,q2,temp,n;

   clrscr();
   printf("Cube\n\n");
   printf("Input delay (100): ");
   scanf("%D",&n);
   printf("Input speed factor (2.0): ");
   scanf("%lf",&ff);
   clrscr();

   n=800*n;


   initgraph(&gdriver,&gmode, "");

   vh=0.0*pi/180.0;
   vv=0.0*pi/180.0;

   sh=sin(vh);
   ch=cos(vh);
   sv=sin(vv);
   cv=cos(vv);

   xx[1]=1; yy[1]=1; zz[1]=1;
   xx[2]=-1; yy[2]=1; zz[2]=1;
   xx[3]=-1; yy[3]=-1; zz[3]=1;
   xx[4]=1; yy[4]=-1; zz[4]=1;

   xx[5]=1; yy[5]=1; zz[5]=-1;
   xx[6]=-1; yy[6]=1; zz[6]=-1;
   xx[7]=-1; yy[7]=-1; zz[7]=-1;
   xx[8]=1; yy[8]=-1; zz[8]=-1;

   randomize();

   rrr=1.0/32767.0;

   w1=0.0;
   w2=0.0;
   w3=0.0;
   ww1=ff*pi/200.0;
   ww2=ff*pi/200.0;
   ww3=0.0;
   f=1000.0;
   r=40.0;
   xs0=320.0;
   ys0=240.0;
   cx=1.0;
   cy=1.0;

   x0=100.0*(rrr*(double)(rand())-0.5);
   y0=100.0*(rrr*(double)(rand())-0.5);
   z0=100.0*(rrr*(double)(rand())-0.5);

   if (rrr*(double)(rand()) > 0.5) {
      dx=ff*1.0;
   }
   else {
      dx=-ff*1.0;
   }
   if (rrr*(double)(rand()) > 0.5) {
      dy=ff*2.0;
   }
   else {
      dy=-ff*2.0;
   }
   if (rrr*(double)(rand()) > 0.5) {
      dz=ff*1.0;
   }
   else {
      dz=-ff*1.0;
   }


   ssx1=-170.0; ssx2=170.0;
   ssy1=-550.0; ssy2=210.0;
   ssz1=-125.0; ssz2=125.0;

   xr2=210.0;
   yr2=400.0;
   zr2=170.0;

   for (i=1; i<=8; i++) {
	 x2=xx[i];
	 y2=yy[i];
	 z2=zz[i];

	 x=-xr2*x2;
	 y=yr2*y2;
	 z=zr2*z2;

	 xr[i]=(int)(cx*(x*(f-y*cv)/f*ch+y*sh)+xs0+0.5);
	 yr[i]=(int)(cy*(z*(f-y*ch)/f*cv+y*sv)+ys0+0.5);
   } /* for i */


   flag=0;
   q=1;

   do {

      for (i=1; i<=8; i++) {
	 x=xx[i];
	 y=yy[i];
	 z=zz[i];

	 ss=sin(w1); cc=cos(w1);
	 x1=x*cc+y*ss;
	 y1=y*cc-x*ss;

	 ss=sin(w3); cc=cos(w3);
	 y2=y1*cc+z*ss;
	 z2=z*cc-y1*ss;

	 ss=sin(w2); cc=cos(w2);
	 x2=x1*cc-z2*ss;
	 z2=z2*cc+x1*ss;

	 x=-r*x2-x0;
	 y=-r*y2-y0;
	 z=r*z2-z0;

	 xs[i][1]=(int)(cx*(x*(f-y*cv)/f*ch+y*sh)+xs0+0.5);
	 ys[i][1]=(int)(cy*(z*(f-y*ch)/f*cv+y*sv)+ys0+0.5);
      } /* for i */

      if (flag == 1) {
	 setcolor(0);
	 q=2;
	 line(xs[1][q],ys[1][q],xs[2][q],ys[2][q]);
	 line(xs[1][q],ys[1][q],xs[5][q],ys[5][q]);
	 line(xs[1][q],ys[1][q],xs[4][q],ys[4][q]);
	 line(xs[2][q],ys[2][q],xs[3][q],ys[3][q]);
	 line(xs[2][q],ys[2][q],xs[6][q],ys[6][q]);
	 line(xs[3][q],ys[3][q],xs[7][q],ys[7][q]);
	 line(xs[3][q],ys[3][q],xs[4][q],ys[4][q]);
	 line(xs[4][q],ys[4][q],xs[8][q],ys[8][q]);
	 line(xs[5][q],ys[5][q],xs[6][q],ys[6][q]);
	 line(xs[6][q],ys[6][q],xs[7][q],ys[7][q]);
	 line(xs[7][q],ys[7][q],xs[8][q],ys[8][q]);
	 line(xs[5][q],ys[5][q],xs[8][q],ys[8][q]);

      } /* if */

	 setcolor(8);
	 line(xr[1],yr[1],xr[2],yr[2]);
	 line(xr[1],yr[1],xr[5],yr[5]);
	 line(xr[1],yr[1],xr[4],yr[4]);
	 line(xr[2],yr[2],xr[3],yr[3]);
	 line(xr[2],yr[2],xr[6],yr[6]);
	 line(xr[5],yr[5],xr[6],yr[6]);
	 line(xr[6],yr[6],xr[7],yr[7]);
	 line(xr[5],yr[5],xr[8],yr[8]);


	 setcolor(4);
	 q=1;
	 line(xs[1][q],ys[1][q],xs[2][q],ys[2][q]);
	 line(xs[1][q],ys[1][q],xs[5][q],ys[5][q]);
	 line(xs[1][q],ys[1][q],xs[4][q],ys[4][q]);
	 line(xs[2][q],ys[2][q],xs[3][q],ys[3][q]);
	 line(xs[2][q],ys[2][q],xs[6][q],ys[6][q]);
	 line(xs[3][q],ys[3][q],xs[7][q],ys[7][q]);
	 line(xs[3][q],ys[3][q],xs[4][q],ys[4][q]);
	 line(xs[4][q],ys[4][q],xs[8][q],ys[8][q]);
	 line(xs[5][q],ys[5][q],xs[6][q],ys[6][q]);
	 line(xs[6][q],ys[6][q],xs[7][q],ys[7][q]);
	 line(xs[7][q],ys[7][q],xs[8][q],ys[8][q]);
	 line(xs[5][q],ys[5][q],xs[8][q],ys[8][q]);

	 setcolor(7);
	 line(xr[3],yr[3],xr[7],yr[7]);
	 line(xr[3],yr[3],xr[4],yr[4]);
	 line(xr[4],yr[4],xr[8],yr[8]);
	 line(xr[7],yr[7],xr[8],yr[8]);

      for (i=1; i<=8; i++) {
	 xs[i][2]=xs[i][1];
	 ys[i][2]=ys[i][1];
      } /* for i */

      flag=1;

      w1=w1+ww1;
      w2=w2+ww2;
      w3=w3+ww3;

      x0=x0+dx;
      y0=y0+dy;
      z0=z0+dz;


      if ((x0 < ssx1) || (x0 > ssx2)) {
	 dx=-dx;
	 ww1=-ww1;
      }

      if ((y0 < ssy1) || (y0 > ssy2)) {
	 dy=-dy;
	 ww3=-ww3;
      }

      if ((z0 < ssz1) || (z0 > ssz2)) {
	 dz=-dz;
	 ww2=-ww2;
      }

      for (j=1; j<=n; j++);

   } while (! kbhit());


   getch();

   closegraph();

} /* End  */
